# generated by datamodel-codegen:
#   filename:  https://api.cookieapp.me/openapi.json

from __future__ import annotations

from datetime import date, datetime

from pydantic import BaseModel, Field

from ._internal import BaseChart


class Chart(BaseChart):
    x: list[date] = Field(..., title="X")
    y: list[int] = Field(..., title="Y")


class Daily(BaseModel):
    ready: bool = Field(..., title="Ready")
    next: datetime = Field(..., title="Next")
    streak: int = Field(..., title="Streak")
    max_streak: int = Field(..., title="Max Streak")


class GuildActivity(BaseModel):
    msg_activity: Chart
    voice_activity: Chart
    msg_count: int = Field(..., title="Msg Count")
    voice_min: int = Field(..., title="Voice Min")
    top_channel: int | None = Field(..., title="Top Channel")
    top_channel_messages: int = Field(..., title="Top Channel Messages")
    most_active_user_day: int | None = Field(..., title="Most Active User Day")
    most_active_user_hour: int | None = Field(..., title="Most Active User Hour")


class GuildStats(BaseModel):
    members: Chart
    boosts: Chart


class MemberActivity(BaseModel):
    msg_activity: Chart
    voice_activity: Chart
    msg_count: int = Field(..., title="Msg Count")
    voice_min: int = Field(..., title="Voice Min")
    msg_rank: int = Field(..., title="Msg Rank")
    voice_rank: int = Field(..., title="Voice Rank")
    current_voice_min: int = Field(..., title="Current Voice Min")


class Oven(BaseModel):
    ready: bool = Field(..., title="Ready")
    next: datetime = Field(..., title="Next")


class Steals(BaseModel):
    total: int = Field(..., title="Total")
    users: int = Field(..., title="Users")
    successful: int = Field(..., title="Successful")
    cookies_gained: int = Field(..., title="Cookies Gained")
    cookies_lost: int = Field(..., title="Cookies Lost")


class TextLevel(BaseModel):
    msg: int = Field(..., title="Msg")
    xp: int = Field(..., title="Xp")
    level: int = Field(..., title="Level")
    current_level_progress: int = Field(..., title="Current Level Progress")
    current_level_end: int = Field(..., title="Current Level End")
    rank: int = Field(..., title="Rank")
    total_members: int = Field(..., title="Total Members")


class ValidationError(BaseModel):
    loc: list[str | int] = Field(..., title="Location")
    msg: str = Field(..., title="Message")
    type: str = Field(..., title="Error Type")


class VoiceLevel(BaseModel):
    minutes: int = Field(..., title="Minutes")
    xp: int = Field(..., title="Xp")
    level: int = Field(..., title="Level")
    rank: int = Field(..., title="Rank")
    total_members: int = Field(..., title="Total Members")
    streak_days: int = Field(..., title="Streak Days")
    cur_voice_min: int = Field(..., title="Cur Voice Min")
    max_voice_min: int = Field(..., title="Max Voice Min")


class Work(BaseModel):
    career: str = Field(..., title="Career")
    total_shifts: int = Field(..., title="Total Shifts")
    current_shifts: int = Field(..., title="Current Shifts")
    job: str = Field(..., title="Job")
    job_level: int = Field(..., title="Job Level")
    job_ready: bool = Field(..., title="Job Ready")
    next_shift: datetime = Field(..., title="Next Shift")


class HTTPValidationError(BaseModel):
    detail: list[ValidationError] | None = Field(None, title="Detail")


class MemberStats(BaseModel):
    level: TextLevel
    voice: VoiceLevel
    greetings: int = Field(..., title="Greetings")
    boost_days: int = Field(..., title="Boost Days")
    profile_url: str = Field(..., title="Profile Url")


class UserStats(BaseModel):
    cookies: int = Field(..., title="Cookies")
    cookie_history: Chart
    job: Work
    steals: Steals
    oven: Oven
    daily: Daily
    profile_url: str = Field(..., title="Profile Url")
